#!/usr/bin/python
# -*- coding: iso-8859-15 -*-

import string, struct, sys

from convert.convert import *
from convert.compression import unpacker_87a7c7
from convert.compression import unpacker_adv2_b
from convert.compression import unpacker_adv2_c

table = "|abcdefghijklmnopqrstuvwxyz__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" 

table2= " abcdefghijklmnopqrstuvwxyz[]^<" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "~ABCDEFGHIJKLMNOPQRSTUVWXYZ    _" + \
        "a_______A________/\\\\/|=-*>v~*}" + \
        "________________________________" + \
        "________________________________" + \
        "________________________________" + \
        "________________________________" 

def domi_translate(data, start = 7) :
    outdata = ""
    i = start
    while i < len(data) :
        char_ord = ord(data[i])
        
        if char_ord >= 0x80 and char_ord <= 0x9f :
            pass
            #outdata += "<color: %d>" % (char_ord - 0x90)
        elif char_ord >= 0xfd :
            outdata += "\n"
            if char_ord == 0xff and data[i+1:i+8] == "\x00\x00\x00\x00\x00\x00\x00" :
                i += 7
        elif char_ord == 0x63 :
            outdata += ":)"
        elif char_ord == 0x72 :
            outdata += "(:"
        else :
            outdata += table2[char_ord]
            if table2[char_ord] == "_" :
                outdata += "<%02x>" % char_ord
                #print line, hex(char)
            
        i+= 1
    return outdata

class Converter(ConverterTemplate) :
    def valid_dir(self, issue, diskside) :
        return issue < 18
        
    def fake_dir(self, issue, diskside) :
        if issue < 18 :
            return
            
        if issue == 18 and diskside == "a" :
            tracks  = (0x11, 0x13, 0x10, 0x0f, 0x15, 0x0e, 0x0d, 0x17, 0x0c, 0x18, 0x0b, 0x0b, 0x19)
            sectors = (0x00, 0x00, 0x00, 0x00, 0x03, 0x09, 0x07, 0x08, 0x00, 0x06, 0x02, 0x13, 0x05)
            dir = []
            for i in xrange(len(tracks)) :
                dir.append(("%02d." % i, tracks[i], sectors[i]))
            return dir
        elif issue == 18 and diskside == "b" :
            tracks  = (0x11, 0x11, 0x17, 0x0c, 0x0c, 0x19, 0x0a, 0x1a, 0x1b, 0x08, 0x1c)
            sectors = (0x00, 0x05, 0x0f, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x06, 0x01)
            dir = []
            for i in xrange(len(tracks)) :
                dir.append(("%02d." % (i+13), tracks[i], sectors[i]))
            return dir
        elif issue == 19 :
            tracks  = (0x0c, 0x11, 0x11, 0x18, 0x13, 0x13, 0x10, 0x15, 0x0e, 0x16, 0x0d, 0x0d, 0x17)
            sectors = (0x07, 0x00, 0x09, 0x00, 0x00, 0x05, 0x02, 0x00, 0x01, 0x05, 0x00, 0x07, 0x0d)
            dir = []
            for i in xrange(len(tracks)) :
                dir.append(("%02d." % i, tracks[i], sectors[i]))
            return dir
        
    def valid_filename(self, issue, filename) :
        if issue == 1 and filename[0:2] == "07" :
            return False
            
        if filename[0] in string.digits and filename[1] in string.digits :
            return True
        else :
            return False
    
    def strip_filename(self, filename) :
        return filename[0:2]
        
    def convert_issue(self, issue, filename, data) :
        if issue <= 3 :
            data = data[2:]
            data = unpacker_87a7c7.unpack(data)
            data = translate(data, table)
        elif issue <= 17 :
            blocks = unpacker_adv2_b.Unpacker(data).unpack()
            data = blocks[0]
            data = domi_translate(data)
        else :
            data = data[2:]
            data = unpacker_adv2_c.Unpacker(data).unpack()
            offset = struct.unpack("<H", data[1:3])[0] - 0xa000
            data = domi_translate(data[offset:], 0)
        return data

mag_name = "domination"
start_issue = int(sys.argv[1])
end_issue = int(sys.argv[2])

conv = Converter(mag_name, start_issue, end_issue)
conv.convert()    