#!/usr/bin/python
# -*- coding: iso-8859-15 -*-

import string, struct, sys

from convert.convert import *
from convert.compression import unpacker_sfx1
from convert.compression import unpacker_sfx2
from convert.compression import unpacker_jam

table = "@abcdefghijklmnopqrstuvwxyz_<" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ_____" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ_____" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ_____" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" 

class Converter(ConverterTemplate) :
    def valid_dir(self, issue, diskside) :
        return True
        
    def fake_dir(self, issue, diskside) :
        return
            
    def valid_filename(self, issue, filename) :
        if filename[0] in string.digits and (filename[1] in string.digits or filename[1] in string.letters) :
            if filename[0:2] != "00" :
                return True
                
        return False
    
    def strip_filename(self, filename) :
        return filename[0:2]
        
    def convert_issue(self, issue, filename, data) :
        if issue == 1 :
            data = data[3:]
            data = translate(data, table)
        elif issue == 2 :
            data = unpacker_sfx1.Unpacker(data).unpack()[2]
            data = data[8:]
            data = translate(data, table)
        elif issue == 3 :
            data = unpacker_sfx1.Unpacker(data).unpack()[0]
            if data[2:4] == "\x00\x00" :
                data = data[4:]
            else :
                data = data[8:]
            data = translate(data, table)
        elif issue >= 4 and issue <= 6 :
            data = unpacker_sfx2.Unpacker(data).unpack()
            if issue != 6 :
                data = data[3:]
            data = translate(data, table)
        else :
            data = unpacker_jam.Unpacker(data).unpack()
            data = data.rstrip("\x00")
            data = translate(data, table)
        
        data = webready(data)
        return data
        
mag_name = "jamaica"
start_issue = int(sys.argv[1])
end_issue = int(sys.argv[2])

conv = Converter(mag_name, start_issue, end_issue)
conv.convert()    