#!/usr/bin/python
# -*- coding: iso-8859-15 -*-

import string, struct, sys

from convert.compression import unpacker_bf
from convert.compression import unpacker_adv1_b
from convert.convert import *

table = " _______________________________" + \
        "________________________________" + \
        "________________________________" + \
        "________________________________" + \
        "________________________________" + \
        "________________________________" + \
        " abcdefghijklmnopqrstuvwxyz___  " + \
        " !\"-#%&'()>+,-./0123456789:;<=*?" 

table2= "|abcdefghijklmnopqrstuvwxyz__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ__^<" + \
        " !\"#$%&'()>+,-./0123456789:;<=*?" 
        
class Converter(ConverterTemplate) :
    def valid_dir(self, issue, diskside) :
        return issue != 18
        
    def fake_dir(self, issue, diskside) :
        if issue != 18 :
            return
        tracks  = (0x15, 0x0e, 0x13, 0x11, 0x0f, 0x15, 0x07, 0x10, 0x0e, 0x15, 0x13, 0x14, 0x10, 0x17, 0x11, 0x07, 0x11)
        sectors = (0x00, 0x03, 0x03, 0x00, 0x01, 0x0a, 0x09, 0x05, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x01, 0x03, 0x06)
        dir = []
        for i in xrange(17) :
            dir.append(("%02d." % i, tracks[i], sectors[i]))
        return dir
        
    def valid_filename(self, issue, filename) :
        if issue == 19 :
            if filename[0] == "C" :
                return True
            else :
                return False
        else :
            if filename[0] in string.digits and filename[1] in string.digits and filename[2] not in string.digits :
                return True
            else :
                return False
    
    def strip_filename(self, filename) :
        return filename[0:2]
        
    def convert_issue(self, issue, filename, data) :
    
        if issue < 14 :
            offset_addr = struct.unpack("<H", data[0:2])[0]
            data = unpacker_bf.unpack(data[2:], offset_addr)
            data = block_crop(data, 0x200, 0x1fe)
            data = translate(data, table, 34)
            
        elif issue >= 18 :
            data = unpacker_adv1_b.Unpacker(data).unpack()
            if data[1] != "\x20" :
                return ""
            data = data[1:]
            data = translate(data, table2)
            
        else :
            if data[2:4] == "\xa9\x00" :
                return ""
                
            offset_addr = struct.unpack("<H", data[0:2])[0]
            data = unpacker_bf.unpack(data[2:], offset_addr)
            data = translate(data, table2)
        
        data = webready(data)
        return data
            

mag_name = "splash"
start_issue = int(sys.argv[1])
end_issue = int(sys.argv[2])

conv = Converter(mag_name, start_issue, end_issue)
conv.convert()    