#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, os, sys, string

from convert import vandalism_news
from d64 import d64

class Unpacker(object) :
    def __init__(self, data) :
        self.data = data
        self.debug = False

    def get_bits(self, numbits) :
        outbits = 0
        for i in xrange(numbits) :
            if self.bitrsv_numbits <= 0 or self.bitrsv_numbits > 127 :
                if self.debug :
                    print "new char", binascii.b2a_hex(self.data[self.bitrsv_ptr])
                self.bitrsv_byte = ord(self.data[self.bitrsv_ptr])
                self.bitrsv_numbits = 8
                self.bitrsv_ptr -= 1
            outbits = outbits << 1
            if self.bitrsv_byte & 128 :
                outbits += 1
            self.bitrsv_byte = (self.bitrsv_byte << 1) % 256
            self.bitrsv_numbits -= 1
        
        #print "outbits", numbits, outbits, self.bitrsv_numbits
        return outbits
        
    def unpack(self) :
        self.bitrsv_byte    = ord(self.data[0x3a])
        self.bitrsv_numbits = ord(self.data[0x3b])
        self.data = self.data[0x12d:]
        self.bitrsv_ptr     = len(self.data) - 1
        self.flag = 0
        #print hex(self.bitrsv_byte), self.bitrsv_numbits
        
        outdata = ""
        
        while True :
            bits = self.get_bits(3)
            if bits != 0 :
                if bits >= 6 :
                    bits = self.get_bits(4 + 4 * (bits & 1)) + 6
                    if bits >= 256 :
                        print "bits too large", bits
                        sys.exit()
                if self.debug :
                    print "numchars", bits
                    print binascii.b2a_hex(self.data[self.bitrsv_ptr-bits+1:self.bitrsv_ptr+1])
                outdata = self.data[self.bitrsv_ptr-bits+1:self.bitrsv_ptr+1] + outdata
                self.bitrsv_ptr -= bits
                if self.bitrsv_ptr < 0 :
                    break
                    
            if not self.flag :
                if self.get_bits(1) :  # test at addr 0x14d
                    offset = self.get_bits(8)
                    numchars = 2
                else :
                    if self.get_bits(1) :
                        numchars = self.get_bits(4 + 4 * self.get_bits(1)) + 4
                        offset = self.get_bits(8 + self.get_bits(1))
                        #print numchars
                    else :
                        numchars = 3
                        offset = self.get_bits(8 + self.get_bits(1))
                    
                for i in xrange(numchars) :
                    if self.debug :
                        print binascii.b2a_hex(outdata[offset+numchars-1]),
                    outdata = outdata[offset+numchars-1] + outdata
                if self.debug :
                    print
                    
                if self.bitrsv_ptr < 0 :
                    break
                    
            else :
                print "flag!"
                sys.exit()
            
        #print self.bitrsv_numbits
        return outdata

d64name = "vandalism_news"
magname = "vandalism news"
for magnumber in xrange(5, 6) :
    magnum = "%02d" % magnumber

    for diskside in "@abcd" :
        if diskside == "@" :
            diskside = ""

        fname = d64name + magnum + diskside + ".d64"
        if not os.path.isfile(fname) :
            continue
            
        print "Processing", magname + magnum + diskside
        f = open(d64name + magnum + diskside + ".d64", "rb")
        disk = f.read()
        f.close()

        img = d64.D64image(disk)
        dir = img.get_dir()
        for entry in dir :
            filename = entry[0]
            if filename[0] in string.digits and filename[1] in string.digits :

                if magnumber == 5 and (filename[0:2] == "00" or filename[0:2] == "04") :
                    continue
                    
                print filename            
                data = img.get_file_by_name(filename)
                data = Unpacker(data).unpack()
                data = data[0x17ff:]
                data = vandalism_news.translate(data)
                fname = magname + "-" + magnum + "-" + filename[0:2] + ".txt"
                #if os.path.isfile(fname) :
                #    print "File exists", fname
                #    fname += "_"
                of = open(fname, "wb")
                of.write(data)
                of.close()
               # sys.exit()
