#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, os, sys, string

from convert import vandalism_news
from d64 import d64

table = "_abcdefghijklmnopqrstuvwxyz[]^<" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "|ABCDEFGHIJKLMNOPQRSTUVWXYZ**--" + \
        " !\"#$%&'() +,-./0123456789:;<=>?"

def convert_txt(data) :
    
    i = 0
    outdata = ""
    while i < len(data) :
        char_ord = ord(data[i])
        
        if char_ord == 0xff :
            outdata += "\n"
            i += 1
        elif char_ord == 0xfe :
            return outdata
        elif char_ord >= 0xfb :
            outdata += "\t"
            i += 1
        elif char_ord == 0x00 :
            outdata += "\n"
            i += 1
        elif char_ord == 0x80 :
            outdata += "  "
            i += 1
        elif char_ord > 0x80 :
            count = ord(data[i+1])
            outdata += table[char_ord-0x80] * count
            if table[char_ord-0x80] == "_" :
                outdata += "<%x>" % (char_ord - 0x80)
            i += 2
        else :
            outdata += table[char_ord]
            if table[char_ord] == "_" :
                outdata += "<%x>" % char_ord
                print outdata[-160:]
                sys.exit()
                
            i += 1
        
    return outdata
        
    
d64name = "vandalism_news"
magname = "vandalism news"
for magnumber in xrange(14, 21) :
    magnum = "%02d" % magnumber

    for diskside in "@abcd" :
        if diskside == "@" :
            diskside = ""

        fname = d64name + magnum + diskside + ".d64"
        if not os.path.isfile(fname) :
            continue
            
        print "Processing", magname + magnum + diskside
        f = open(d64name + magnum + diskside + ".d64", "rb")
        disk = f.read()
        f.close()

        img = d64.D64image(disk)
        dir = img.get_dir()
        for entry in dir :
            filename = entry[0]
            if filename[0] in "01234" and filename[1] in string.digits and filename[2] not in string.digits :
                print filename
                data = img.get_file_by_name(filename)
                if magnumber > 17 :
                    data = vandalism_news.unpack(data)
                if data[0:2] == "\xf8\x3f" :
                    data = data[10:]
                elif data[0:2] == "\x00\x40" :
                    data = data[2:]
                else :
                    print "invalid start address", binascii.b2a_hex(data[0:2])
                    sys.exit()
                data = convert_txt(data)
                fname = magname + "-" + magnum + "-" + filename[0:2] + ".txt"
                if os.path.isfile(fname) :
                    print "File exists", fname
                    #fname += "_"
                of = open(fname, "wb")
                of.write(data)
                of.close()
