import os

from d64 import d64

class ConverterTemplate(object) :
    def __init__(self, mag_name, start_issue, end_issue = -1) :
        self.mag_name    = mag_name
        self.start_issue = start_issue
        if end_issue == -1 :
            self.end_issue = start_issue
        else :
            self.end_issue = end_issue
        
    def convert(self) :
        for issue in xrange(self.start_issue, self.end_issue + 1) :
            issue_txt = "%02d" % issue

            for diskside in "@abcd" :
                if diskside == "@" :
                    diskside = ""

                fname = "%s-%s%s.d64" % (self.mag_name, issue_txt, diskside)
                if not os.path.isfile(fname) :
                    continue
                
                print "Processing", fname
                f = open(fname, "rb")
                disk = f.read()
                f.close()

                img = d64.D64image(disk)
                
                if self.valid_dir(issue, diskside) :
                    dir = img.get_dir()
                else :
                    dir = self.fake_dir(issue, diskside)
                for entry in dir :
                    filename = entry[0]
                    if not self.valid_filename(issue, filename) :
                        continue
                    
                    print filename
                    if self.valid_dir(issue, diskside) :
                        data = img.get_file_by_name(filename)
                    else :
                        data = img.get_file_by_pos(entry[1], entry[2])
                        
                    #fname = "%s-%s-%s.raw" % (self.mag_name, issue_txt, self.strip_filename(filename))
                    #of = open(fname, "wb")
                    #of.write(data)
                    #of.close()
                    
                    data = self.convert_issue(issue, filename, data)
                    if data == "" :
                        continue
                        
                    fname = "%s-%s-%s.txt" % (self.mag_name, issue_txt, self.strip_filename(filename))
                    #while os.path.isfile(fname) :
                    #    print "File exists", fname
                    #    fname = "_" + fname
                    of = open(fname, "wb")
                    of.write(data)
                    of.close()
                    
def translate(data, table, width = 40) :
    outdata = ""
    line = ""
    for i in xrange(len(data)) :
        char = ord(data[i])
        line += table[char]
        
        if table[char] == "_" :
            line += "<%02x>" % char
            print line, hex(char)
       
        if i % width == (width - 1) :
            outdata += line.rstrip() + "\n"
            line = ""
            
    return outdata + line.rstrip() + "\n"
    
def block_crop(data, blocksize, cropsize) :
    outdata = ""
    for i in xrange(0, len(data), blocksize) :
        outdata += data[i:i+cropsize]
    return outdata
    
def webready(data) :
    data = data.replace("&", "&amp;")
    data = data.replace("<", "&lt;")
    data = data.replace(">", "&gt;")
    
    data = "<pre>" + data + "</pre>"
    return data
