#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, struct, sys

def webready(data) :
    data = data.replace("&", "&amp;")
    data = data.replace("<", "&lt;")
    data = data.replace(">", "&gt;")
    
    data = "<pre>" + data + "</pre>"
    return data

class Unpacker(object) :
    def __init__(self, data, controlbyte) :
        self.data = data
        self.index = 2
        self.controlbyte = controlbyte
        
    def get_byte(self) :
        try :
            byte = ord(self.data[self.index])
        except IndexError :
            return -1
        self.index += 1
        return byte
        
    def unpack(self) :
        block = ""
        while True :
            byte = self.get_byte()
            if byte == -1 :
                break
            elif byte == self.controlbyte :
                count = self.get_byte()
                repeatbyte = self.get_byte()
                block += chr(repeatbyte) * count
            else :
                block += chr(byte)
                        
        return block
        
table = "_abcdefghijklmnopqrstuvwxyz+_^v" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ+_^v" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ+_^v" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ+_^v" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" 
                  
def translate(data) :    
    outdata = ""
    line = ""
    for i in xrange(len(data)) :
        char = ord(data[i])
        line += table[char]
        
        if table[char] == "@" :
            print line, hex(char)
        
        if i % 32 == 31 :
            outdata += line.rstrip() + "\n"
            line = ""
            
    return outdata + line.rstrip() + "\n"

table2 =" abcdefghijklmnopqrstuvwxyz@@@@@" + \
        " !\"#$,&'()*+,-./0123456789:;<=>?" + \
        "@||||||||||||||||||||||||||@@@@@" + \
        " |||||||||@@@@@@@@@-@ @@@@@@@@@@" + \
        "@ABCDEFGHIJKLMNOPQRSTUVWXYZ  @@@" + \
        " !\"#$%&'()*+,-./0123456789:@ @ ?" + \
        "@ABCDEFGHIJKLMNOPQRSTUVWXYZ@ @@@" + \
        " !\"#$%&'()*+,-./0123456789:@ @ ?" 
    
def translate2(data) :    
    outdata = ""
    line = ""
    for i in xrange(len(data)) :
        char = ord(data[i])
        line += table2[char]

        if table2[char] == "@" :
            print line, hex(char)
        
        if i % 40 == 39 :
            outdata += line.rstrip() + "\n"
            line = ""
            
    return outdata + line.rstrip() + "\n"    