#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, struct, sys

class Unpacker(object) :
    def __init__(self, data) :
        self.data = data
        self.xor = ord(data[0x42])
        self.controlbyte = ord(data[0x6a])
        self.index = 0x9e
        print "bytes", hex(self.xor), hex(self.controlbyte)
        
    def get_byte(self) :
        byte = ord(self.data[self.index]) ^ self.xor
        self.index += 1
        return byte
        
    def unpack(self) :
        
        blocks = []
        block = ""
        while True :
            byte = self.get_byte()
            if byte != self.controlbyte :
                block += chr(byte)
            else :
                count = self.get_byte()
                if count >= 3 :
                    repeatbyte = self.get_byte()
                    block += chr(repeatbyte) * count
                elif count == 2 :
                    block += chr(controlbyte)
                else :
                    addr_lo = self.get_byte()
                    addr_hi = self.get_byte()
                    #print "start of new data block", hex(addr_lo + addr_hi * 256)
                    blocks.append(block)
                    block = ""
                    if addr_hi == 0 :
                        break
                        
        return blocks

class Unpacker2(object) :
    def __init__(self, data) :
        self.data = data
        self.control1 = ord(data[0x3f])
        self.control2 = ord(data[0x43])
        self.control3 = ord(data[0x47])
        self.control4 = ord(data[0x4c])
        self.index = 0x8e
        print hex(self.control1), hex(self.control2), hex(self.control3), hex(self.control4)
        
    def get_byte(self) :
        if self.index == len(self.data) :
            return False
        byte = ord(self.data[self.index])
        self.index += 1
        return byte
        
    def unpack(self) :
        block = ""
        while True :
            byte = self.get_byte()
            if byte == False :
                break
            if byte == self.control1 :
                count = self.get_byte()
                block += "\x00" * count            
            elif byte == self.control2 :
                repeatbyte = self.get_byte()
                block += chr(repeatbyte) * 3
            elif byte == self.control3 :
                block += "\x00" * 2
            elif byte == self.control4 :
                repeatbyte = self.get_byte()
                count = self.get_byte()
                block += chr(repeatbyte) * (count + 1)
            else :
                block += chr(byte)
                        
        return block

class Unpacker3(object) :
    def __init__(self, data) :
        self.data = data
        self.index = 2
        self.control = ord(data[-1])
        
    def get_byte(self) :
        try :
            byte = ord(self.data[self.index])
        except IndexError :
            return -1
        self.index += 1
        return byte
        
    def unpack(self) :
        block = ""
        while True :
            byte = self.get_byte()
            if byte == -1 :
                break
            elif byte == self.control :
                repeatbyte = self.get_byte()
                count = self.get_byte()
                block += chr(repeatbyte) * (count + 1)
            else :
                block += chr(byte)
                        
        return block
        
table = "_abcdefghijklmnopqrstuvwxyz_<" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ_____" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ_____" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ_____" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" 
                  
def translate(data) :    
    outdata = ""
    line = ""
    for i in xrange(len(data)) :
        char = ord(data[i])
        line += table[char]
        
        #if table[char] == "_" :
        #    print line, hex(char)
       
        if i % 40 == 39 :
            outdata += line.rstrip() + "\n"
            line = ""
            
    return outdata + line.rstrip() + "\n"