#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, struct, sys

trans_table = {
                0x00 : "*",
                0x01 : "*",
                0x02 : "\\",
                0x03 : "/",
                0x04 : ".",
                0x05 : ".",
                0x06 : "\\",
                0x07 : "/",
                0x08 : "-",
                0x09 : "-",
                0x0a : "/",
                0x0b : "\\",
                0x0c : ">",
                0x0d : "<",
                0x0e : "T",
                0x0f : "o",
                0x10 : "p",
                0x11 : "-",
                0x12 : "-",
                0x13 : "-",
                0x14 : "1",
                0x15 : " ",
                0x16 : "0",
                0x17 : "d",
                0x18 : "=",
                0x19 : "b",
                0x1a : "'",
                0x1b : "o",
                0x1c : "'",
                0x1d : "/",
                0x1e : "_",
                0x1f : "\\",
                0x20 : " ",
                0x21 : "@",
                0x3c : "[",
                0x3d : "",
                0x3e : "]",
                0x3f : "|", # arrow up
                0x40 : "<",
                0x41 : "!",
                0x42 : "\"",
                0x43 : "#",
                0x44 : "$",
                0x45 : "%",
                0x46 : "&",
                0x47 : "'",
                0x48 : "(",
                0x49 : ")",
                0x4a : "*",
                0x4b : "+",
                0x4c : ",",
                0x4d : "-",
                0x4e : ".",
                0x4f : "/",
                0x5a : ":",
                0x5b : ";",
                0x5c : "_",
                0x5d : "=",
                0x5e : "?",
                0x79 : "[",
                0x7a : "]",
                0x7b : "!",
                0x7c : "\"",
                0x7d : "%",
                0x7e : "&",
                0x7f : "'",
                0x80 : "(",
                0x81 : ")",
                0x82 : "+",
                0x83 : ",",
                0x84 : ".",
                0x85 : "/",
                0x86 : "O",
                0x90 : ":",
                0x91 : ";",
                0x92 : "<",
                0x93 : ">",
                0x94 : "?",
                
                0xc8 : "|",
                
                0xd4 : "+",
                0xd5 : "-",
                0xd6 : "+",
                0xd7 : "|",
                0xd8 : "|",
                0xd9 : "+",
                0xda : "-",
                0xdb : "+",
                
                0xdc : "+",
                0xdd : "-",
                0xde : "+",
                0xdf : "|",
                0xe0 : "|",
                0xe1 : "+",
                0xe2 : "-",
                0xe3 : "+",
                
                0xf2 : " ", #odd char
                            }

largechar_table = {
                    "\xb5\xc8" : "A",
                    "\xb6\xc9" : "B",
                    "\xb7\xca" : "C",
                    "\xb8\xc9" : "D",
                    "\xb9\xca" : "E",
                    "\xb9\xcb" : "F",
                    "\xba\xcc" : "G",
                    "\xbb\xc8" : "H",
                    "\xbc\x9d" : "I",
                    "\xbd\xcd" : "J",
                    "\xbe\xc8" : "K",
                    "\xbf\xca" : "L",
                    "\xc0\xc8" : "M",
                    "\xc1\xc8" : "N",
                    "\xc1\xa8" : "O",
                    "\xc2\xcb" : "P",
                    "\xc1\xce" : "Q",
                    "\xb6\xc8" : "R",
                    "\xc3\xcf" : "S",
                    "\xc4\x9d" : "T",
                    "\xc5\xa8" : "U",
                    "\xc5\xa9" : "V",
                    "\xc5\xaa" : "W",
                    "\xc6\xc8" : "X",
                    "\xc5\xd0" : "Y",
                    "\xc7\xd1" : "Z",
                    "\xbc\x84" : "!",
                    }


class Unpacker(object) :
    def __init__(self, data) :
        self.data = data
        self.debug = False

    def get_bits(self, numbits) :
        outbits = 0
        for i in xrange(numbits) :
            if self.bitrsv_numbits < 0 or self.bitrsv_numbits > 127 :
                if self.debug :
                    print "new char", binascii.b2a_hex(self.data[self.bitrsv_ptr])
                self.bitrsv_byte = ord(self.data[self.bitrsv_ptr])
                self.bitrsv_numbits = 7
                self.bitrsv_ptr -= 1
            outbits = outbits << 1
            if self.bitrsv_byte & 128 :
                outbits += 1
            self.bitrsv_byte = (self.bitrsv_byte << 1) % 256
            self.bitrsv_numbits -= 1
                
        return outbits
        
    def unpack(self) :
        self.numbit_table = [3,4,5,6,7,7,8,9,4,4,5,6,7,9,0xa,0,0]
        self.offset_table = [0x000,0x008,0x018,0x038,0x078,0x0f8,0x178,0x278,0x000,0x010,0x020,0x040,0x080,0x100,0x300,0x700,0]
        
        self.bitrsv_ptr = len(self.data) - 15
        self.data = self.data[0] + self.data[len(self.data) - 14] + self.data[2:]
        self.offset_table[16] = ord(self.data[len(self.data) - 13]) * 256
        self.numbit_table[15] = ord(self.data[len(self.data) - 12])
        self.numbit_table[16] = ord(self.data[len(self.data) - 11])
        self.numbits_alt      = ord(self.data[len(self.data) - 10])
        self.unknown_byte     = ord(self.data[len(self.data) - 7])
        self.bitrsv_byte      = ord(self.data[len(self.data) - 6])
        self.bitrsv_numbits   = ord(self.data[len(self.data) - 5])
        
        outdata = ""

        while True :
            if self.get_bits(1) == 1 :
                if self.get_bits(1) == 1 :
                    numchars = 1
                else :
                    bits = self.get_bits(2)
                    if bits < 2 :
                        numchars = bits + 2
                    elif bits == 2 :
                        numchars = self.get_bits(1) + 4
                    else :
                        bits = self.get_bits(3)
                        if bits != 7 :
                            numchars = bits + 6
                        else :
                            bits = self.get_bits(4)
                            if bits != 15 :
                                numchars = bits + 13
                            else :
                                numchars = self.get_bits(self.numbits_alt)
                if self.debug :
                    print "numchars", numchars
                    print binascii.b2a_hex(self.data[self.bitrsv_ptr-numchars+1:self.bitrsv_ptr+1])
                outdata = self.data[self.bitrsv_ptr-numchars+1:self.bitrsv_ptr+1] + outdata
                self.bitrsv_ptr -= numchars
                if self.bitrsv_ptr < 0 :
                    break
            
            bit_add = 0
            if self.get_bits(1) == 1 :
                numchars = 2
            else :
                bit_add = 8
                if self.get_bits(1) == 0 :
                    numchars = 3
                else :
                    bits = self.get_bits(2)
                    if bits < 2 :
                        numchars = bits + 4
                    elif bits == 2 :
                        numchars = self.get_bits(2) + 6
                    else :
                        numchars = self.get_bits(5) + 10
                        if numchars == 15 :
                            numchars = self.get_bits(9)
                        elif numchars == 16 :
                            numchars = self.get_bits(5) + 42
                
            bits = self.get_bits(3) + bit_add
            offset = self.offset_table[bits] + self.get_bits(self.numbit_table[bits])
            if offset == self.unknown_byte :
                offset = self.offset_table[16] + self.get_bits(self.numbit_table[16])
            if self.debug :
                print "numchars", numchars, "offset", offset
            for i in xrange(numchars) :
                if self.debug :
                    print binascii.b2a_hex(outdata[offset]),
                outdata = outdata[offset] + outdata
            if self.debug :
                print

        if self.bitrsv_numbits != -1 :
            print "wrong numbits left", self.bitrsv_numbits
            sys.exit()

        return outdata

def remove_headers(data) :
    outdata = ""
    index = 0
    while index < len(data) :
        new_index = index + struct.unpack("<H", data[index:index+2])[0]
        if new_index == index :
            break
        outdata += data[index+2:new_index]
        index = new_index
    return outdata

def expand(data) :
    outdata = ""
    index = 0
    while index < len(data) :
        if data[index] == "\xff" :
            count = ord(data[index + 1])
            if count == 0 :
                count = 256
            outdata += (data[index + 2] * count)
            index += 3
        else :
            outdata += data[index]
            index += 1
            
    return outdata

def translate(data) :    
    outdata = ""
    line = ""
    numlines = 0
    for i in xrange(len(data)) :
        char_ord = ord(data[i])
        if (i + 40) < len(data) and largechar_table.has_key(data[i] + data[i+40]) :
            line += largechar_table[data[i] + data[i+40]]
        elif i >= 40 and largechar_table.has_key(data[i-40] + data[i]) :
            line += largechar_table[data[i-40] + data[i]]
        elif char_ord >= 0x22 and char_ord <= 0x3b :
            line += chr(char_ord + 31)
        elif char_ord >= 0x50 and char_ord <= 0x59 :
            line += chr(char_ord - 32)
        elif char_ord > 0x5e and char_ord < 0x79 :
            line += chr(char_ord + 2)
        elif char_ord > 0x86 and char_ord < 0x90 :
            line += chr(char_ord - 86)
        elif char_ord > 0x94 and char_ord < 0xa3 :
            line += chr(char_ord - 84)
        elif char_ord > 0xa2 and char_ord < 0xaf :
            line += chr(char_ord - 83)
        elif trans_table.has_key(char_ord) :
            line += trans_table[char_ord]
        else :
            line += "_" + hex(char_ord) + "_"
            print line
            sys.exit()

        if i % 40 == 39 :
            outdata += line.rstrip() + "\n"
            line = ""
            numlines += 1
            if numlines % 20 == 0:
                outdata += "\n"
            
    return outdata