#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, struct, sys

def unpack(data) :
    try :

        outdata = ""
        i = 0
        while i < len(data) :
            if data[i] == "\xc7" :
                count = ord(data[i + 1])
                if count == 0 :
                    outdata += "\xc7"
                    i += 2
                else :
                    outdata += (data[i + 2] * count)
                    i += 3
            elif data[i] == "\xa7" :
                count = ord(data[i + 1])
                if count == 0 :
                    outdata += "\xa7"
                    i += 2
                else :
                    dist = ord(data[i + 2])
                    for j in xrange(count) :
                        outdata += outdata[-dist]
                    i += 3
            elif data[i] == "\x87" :
                count = ord(data[i + 1])
                if count == 0 :
                    outdata += "\x87"
                    i += 2
                else :
                    dist = ord(data[i + 2]) + 256 * ord(data[i + 3])
                    for j in xrange(count) :
                        outdata += outdata[-dist]
                    i += 4
            else :
                outdata += data[i]
                i += 1
                
        return outdata
    except IndexError :
        print binascii.b2a_hex(data[i-8:i+4]), hex(len(outdata))
        raise

def unpack2(data) :
    outdata = ""
    i = 0
    while i < len(data) :
        if data[i] == "\xc7" :
            count = ord(data[i + 1])
            if count == 0 :
                outdata += "\xc7"
                i += 2
            else :
                outdata += (data[i + 2] * count)
                i += 3
        else :
            outdata += data[i]
            i += 1
            
    return outdata

def unpack3(data) :
    outdata = ""
    i = 0
    while i < len(data) :
        if data[i:i+2] == "\x7c\x3c" :
            count = ord(data[i + 2]) + ord(data[i + 3]) * 256
            if count == 0xffff :
                return outdata
            outdata += (data[i + 4] * count)
            i += 5
        else :
            outdata += data[i]
            i += 1
            
    return outdata
    
class Unpacker(object) :
    def __init__(self, data) :
        self.data = data
        self.debug = False

    def get_bits(self, numbits) :
        outbits = 0
        for i in xrange(numbits) :
            if self.bitrsv_numbits < 0 or self.bitrsv_numbits > 127 :
                if self.debug :
                    print "new char", binascii.b2a_hex(self.data[self.bitrsv_ptr])
                self.bitrsv_byte = ord(self.data[self.bitrsv_ptr])
                self.bitrsv_numbits = 7
                self.bitrsv_ptr -= 1
            outbits = outbits << 1
            if self.bitrsv_byte & 128 :
                outbits += 1
            self.bitrsv_byte = (self.bitrsv_byte << 1) % 256
            self.bitrsv_numbits -= 1
                
        return outbits
        
    def unpack(self) :
        self.numbit_table = [3,4,5,6,7,7,8,9,4,4,5,6,7,9,0xa,0,0]
        self.offset_table = [0x000,0x008,0x018,0x038,0x078,0x0f8,0x178,0x278,0x000,0x010,0x020,0x040,0x080,0x100,0x300,0x700,0]
        
        self.bitrsv_ptr = len(self.data) - 15
        self.data = self.data[0] + self.data[len(self.data) - 14] + self.data[2:]
        self.offset_table[16] = ord(self.data[len(self.data) - 13]) * 256
        self.numbit_table[15] = ord(self.data[len(self.data) - 12])
        self.numbit_table[16] = ord(self.data[len(self.data) - 11])
        self.numbits_alt      = ord(self.data[len(self.data) - 10])
        self.unknown_byte     = ord(self.data[len(self.data) - 7])
        self.bitrsv_byte      = ord(self.data[len(self.data) - 6])
        self.bitrsv_numbits   = ord(self.data[len(self.data) - 5])
        
        outdata = ""

        while True :
            if self.get_bits(1) == 1 :
                if self.get_bits(1) == 1 :
                    numchars = 1
                else :
                    bits = self.get_bits(2)
                    if bits < 2 :
                        numchars = bits + 2
                    elif bits == 2 :
                        numchars = self.get_bits(1) + 4
                    else :
                        bits = self.get_bits(3)
                        if bits != 7 :
                            numchars = bits + 6
                        else :
                            bits = self.get_bits(4)
                            if bits != 15 :
                                numchars = bits + 13
                            else :
                                numchars = self.get_bits(self.numbits_alt)
                if self.debug :
                    print "numchars", numchars
                    print binascii.b2a_hex(self.data[self.bitrsv_ptr-numchars+1:self.bitrsv_ptr+1])
                outdata = self.data[self.bitrsv_ptr-numchars+1:self.bitrsv_ptr+1] + outdata
                self.bitrsv_ptr -= numchars
                if self.bitrsv_ptr < 0 :
                    break
            
            bit_add = 0
            if self.get_bits(1) == 1 :
                numchars = 2
            else :
                bit_add = 8
                if self.get_bits(1) == 0 :
                    numchars = 3
                else :
                    bits = self.get_bits(2)
                    if bits < 2 :
                        numchars = bits + 4
                    elif bits == 2 :
                        numchars = self.get_bits(2) + 6
                    else :
                        numchars = self.get_bits(5) + 10
                        if numchars == 15 :
                            numchars = self.get_bits(9)
                        elif numchars == 16 :
                            numchars = self.get_bits(5) + 42
                
            bits = self.get_bits(3) + bit_add
            offset = self.offset_table[bits] + self.get_bits(self.numbit_table[bits])
            if offset == self.unknown_byte :
                offset = self.offset_table[16] + self.get_bits(self.numbit_table[16])
            if self.debug :
                print "numchars", numchars, "offset", offset
            for i in xrange(numchars) :
                if self.debug :
                    print binascii.b2a_hex(outdata[offset]),
                outdata = outdata[offset] + outdata
            if self.debug :
                print

        if self.bitrsv_numbits != -1 :
            print "wrong numbits left", self.bitrsv_numbits
            sys.exit()

        return outdata

class NoMoreData(Exception) :
    pass
    
class Unpacker2(object) :
    def __init__(self, data, only_first = False) :
        self.data = data
        self.only_first = only_first
        
    def get_byte(self) :
        if self.num_bytes :
            byte = ord(self.data[self.ptr])
            self.ptr += 1
            self.num_bytes -= 1
            return byte
        else :
            raise NoMoreData

    def get_bit(self) :
        #print "control byte", hex(self.control_byte)
        if self.control_byte & 128 :
            bit = 1
        else :
            bit = 0
        self.control_byte = (self.control_byte << 1) & 255
        if self.control_byte == 0 :
            self.control_byte = (self.get_byte() << 1) + 1
            #print "   - new control byte", hex((self.control_byte - 1) >> 1 )
            if self.control_byte & 256 :
                bit = 1
                self.control_byte &= 255
            else :
                bit = 0
        return bit
            

    def unpack(self) :
        blocks = []
        self.ptr = 0
        
        while self.ptr < len(self.data) :
            self.num_bytes = 65536
            num_bytes_temp = self.get_byte() * 256 + self.get_byte()
            self.get_byte()
            self.get_byte()
            self.control_byte = self.get_byte()
            self.num_bytes = num_bytes_temp
            print self.num_bytes, len(self.data)
            
            a = 0
            self.outdata = ""
            
            try :
                while True :
                    a = self.get_bit()
                    if a != 0 :
                        #print "Getting new data"
                        while self.get_bit() :
                            a = (a << 1) + self.get_bit()

                        #print "a", a
                        for i in xrange(a) :
                            self.outdata = chr(self.get_byte()) + self.outdata
                            #print binascii.b2a_hex(self.outdata[0]),
                        #print 
                    
                    a = self.get_bit()
                    #print "dsdd"
                    if a != 0 :
                        while self.get_bit() :
                            a = (a << 1) + self.get_bit()
                            if a & 128 :
                                break
                        #print "ddddaqw", hex(a)
                        x = 4
                    else :
                        x = 0
                    a += 2
                    x += self.get_bit() * 2 + self.get_bit()
                    #print "x", x
                    
                    bar = 0
                    while True :
                        foo = [4,2,2,2,5,2,2,3][x]
                        #print "foo", foo
                        for i in xrange(foo) :
                            bar = (bar << 1) + self.get_bit()
                        #print hex(bar)
                        if x & 3 == 0 :
                            break
                        x -= 1
                        bar += 1

                    #print "bar", bar
                     
                    for i in xrange(a) :
                        #print binascii.b2a_hex(self.outdata[bar + a]),
                        self.outdata = self.outdata[bar + a - 1] + self.outdata
                    #print
            except NoMoreData :
                blocks.append(self.outdata)
                if self.only_first :
                    break
                #print binascii.b2a_hex(self.outdata[0:4])
            
        return blocks

class Translator(object) :
    def __init__(self, data) :
        self.data = data
        self.index = 0
        
    def getchar(self) :
        char = ord(self.data[self.index])
        self.index += 1
        if self.index == len(self.data) :
            raise NoMoreData
        return char
        
    def convert(self, char) :
        if char == 127 :
            char = 32
        elif char == 0 :
            char = ord("@")
        elif char >= 1 and char <= 26 :
            char += 96
        return char
    
    def get_indent(self) :
        indent_hi = self.getchar()
        if indent_hi == 3 :
            self.getchar()
            self.getchar()
            indenttext = ""
        elif indent_hi :
            indent_lo = self.getchar()
            indent_num = ((indent_hi & 0x80) << 1) + indent_lo
            indenttext = "    "
        else :
            indenttext = ""

        return indenttext

    def skip_gfx(self) :
        address = self.getchar() + self.getchar() * 256
        #print "address", address
        while True :
            repeat = self.getchar()
            #print "repeat", repeat
            if repeat == 0xff :
                repeat = self.getchar() + self.getchar() * 256
            for i in xrange(repeat) :
                self.getchar()
            
            backtrack = self.getchar()
            #print "backtrack", hex(backtrack)
            
            if backtrack == 0:
                return
                
            self.getchar()
            
        
    def translate(self) :
        outdata = ""
        try :
            while True :
            
                color = self.getchar()
                    
                colormap = self.getchar()
                if colormap :
                    self.skip_gfx()

                bitmap = self.getchar()
                if bitmap :
                    self.skip_gfx()
                    #outdata += "\n<image>\n"
                    
                numrasters = 0
                while True :
                    rasterstuff = self.getchar()
                    #print "rasterstuff", rasterstuff

                    if rasterstuff >= 0x80 :
                        numrasters += 1
                    else :
                        break

                if numrasters :
                    colormap2 = self.getchar()
                    if colormap2 :
                        self.skip_gfx()

                outdata += self.get_indent()
                
                while True :
                    char = self.getchar()
                    if char < 0x80 :
                        outdata += chr(self.convert(char))
                    elif char >= 0xa0 and char <= 0xaf :
                        #outdata += "<color: " + str(char - 0xa0) + ">"
                        pass
                    elif char == 0xf0 :
                        repeatnum = self.getchar()
                        repeatchar = chr(self.convert(self.getchar()))
                        outdata += (repeatnum * repeatchar)
                    elif char == 0xfd :
                        #outdata += "\n\n<new page>\n\n"
                        outdata += "\n\n"
                        break
                    elif char >= 0xfe :
                        outdata += "\n"
                        outdata += self.get_indent()
                    elif char == 0x90 :
                        outdata += "\t"
                    elif char == 0x91 :
                        outdata += "\t\t"
                    elif char == 0x92 :
                        outdata += "\t\t\t"
                    elif char == 0x93 :
                        outdata += "\t\t\t\t"
                        
                    else :
                        outdata += "<Unknown code: " + hex(char) + ">"
                        pass
                        
        except NoMoreData :
            return outdata
                    
        return outdata

table = "_abcdefghijklmnopqrstuvwxyz" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" 
                  
def translate(data) :    
    outdata = ""
    line = ""
    for i in xrange(len(data)) :
        char = ord(data[i])
        line += table[char]
       
        if i % 40 == 39 :
            outdata += line.rstrip() + "\n"
            line = ""
            
    return outdata